/**************************************************************************/
/*  Implementation of a simple semi-unification algorithm (Henglein 1993) */
/*  Copyright (C) 2012. Michael Lienhardt                                 */
/*                                                                        */
/*  This program is free software; you can redistribute it and/or modify  */
/*  it under the terms of the GNU General Public License as published by  */
/*  the Free Software Foundation; version 2 of the License.               */
/*                                                                        */
/*  This program is distributed in the hope that it will be useful, but   */
/*  WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     */
/*  General Public License for more details.                              */
/*                                                                        */
/*  You should have received a copy of the GNU General Public License     */
/*  along with this program; if not, write to the Free Software           */
/*  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA         */
/*  02110-1301 USA                                                        */
/*                                                                        */
/**************************************************************************/

package deadlock.analyser.factory;

import java.util.List;
import java.util.ArrayList;

import deadlock.constraints.term.Term;
import deadlock.constraints.term.TermStructured;

public class MethodContract extends TermStructured {

  public static String name = "MethodContract";

  /* Constructors */
  public MethodContract(List<Term> l) { super(name, l); }

  public MethodContract(MethodInterface mi, Contract contract){
    super(name, new ArrayList<Term>(2));
    subterms.add(mi);
    subterms.add(contract);
  }

  /* Basic Get */
  public MethodInterface getMethodInterface() { return (MethodInterface)subterms.get(0); }
  public Contract getContract() { return (Contract)subterms.get(1); }

  /* Basic Manipulation */
  public void clean() { getContract().clean(); }

  /* toString */
  public String toString() {
    return (subterms.get(0).toString()) + " { " + (subterms.get(1).toString()) + " } ";
  }

}


